"""Analytics manager errors."""


class AnalyticsLoaderException(Exception):
    """Analytics loader exception."""


class AnalyticsException(Exception):
    """Analytics manager common exception."""


class VideoException(Exception):
    """Frame load exception."""

    def __init__(self, *args, videoException: Exception):
        super().__init__(*args)
        self.originalException = videoException


class ManagerPublicException(Exception):
    """
    Analytics manager public exception. Collects all the errors occurred while processing.
    Args:
        errors (list[ManagerCommonException]): processing errors
    """

    def __init__(self, *args, errors: list[AnalyticsException]):
        super().__init__(*args)
        self.errors = errors


class FrameLoadFailure(AnalyticsException):
    """Manager failed to load frame."""


class FrameCtxFailure(AnalyticsException):
    """Analytics failed to prepare frame context."""


class AnalyticsFailure(AnalyticsException):
    """Analytics failed to perform some operations."""
