from luna_analytics_manager.monitoring.monitoring import NodeMonitoringPoint
from luna_analytics_manager.monitoring.storage import NODES_STORAGE


def nodeMonitoring(pointClass: type[NodeMonitoringPoint] = NodeMonitoringPoint):
    """Wrap node with monitoring"""

    def monitoring(func):
        async def wrapper(self, frameCtx, ctx):
            with NODES_STORAGE.monitoring(pointClass("node_" + self.name)) as point:
                if hasattr(self, "monitoring"):
                    self.monitoring[frameCtx.number] = point
                    try:
                        return await func(self, frameCtx, ctx)
                    finally:
                        del self.monitoring[frameCtx.number]
                else:
                    return await func(self, frameCtx, ctx)

        return wrapper

    return monitoring
